<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge" />
    <title>Lazy Loading</title>
    <link rel="stylesheet" type="text/css" href="style.css">
</head>

<body>
    <div class="App">
        <nav>
            <div class="row navBar">
                <div class="fontSize22px">🧮</div>
                <ul class="row navSub">
                    <li>🔔</li>
                    <li>🔍 </li>
                </ul>
            </div>
        </nav>

        <div>
            <ul class="hide row paginationBar" id="pagination">
            </ul>
        </div>

        <main>

            <div id="loadingArray">
            </div>


            <div>
                <div id="movies">
                </div>
                <div className="virtual">
                    <img class="lazyLoading virtual " alt="" height="50" width="50"
                        src="cupertino_activity_indicator.gif"></img>
                </div>
            </div>

        </main>
    </div>

    <script>
        // Function to create and append an HTML element
        function createElement(tag, attributes) {
            const element = document.createElement(tag);
            for (const key in attributes) {
                if (attributes.hasOwnProperty(key)) {
                    element.setAttribute(key, attributes[key]);
                }
            }
            return element;
        }

        function setPageNumber(newPageNumber) {
            pageNumber = newPageNumber;
            fetchMovies(newPageNumber);
        }

        // Function to update the pagination bar based on the page number and total pages
        function updatePagination(pageNumber, totalPages) {
            const paginationContainer = document.getElementById('pagination');
            paginationContainer.innerHTML = '';

            // Helper function to create a pagination item
            function createPaginationItem(text, onClickHandler) {
                const li = createElement('li', {});
                li.textContent = text;
                li.addEventListener('click', onClickHandler);
                paginationContainer.appendChild(li);
            }

            const tp = totalPages;

            function addCounter() {
                if (pageNumber < totalPages) {
                    setPageNumber(pageNumber + 1);
                }
            }

            function delCounter() {
                if (pageNumber > 1) {
                    setPageNumber(pageNumber - 1);
                }
            }

            if (!totalPages) {
                return;
            }

            if (pageNumber > 0 && pageNumber < tp - 4 && totalPages) {
                createPaginationItem('<', delCounter);

                for (let i = pageNumber - 1; i <= pageNumber + 4; i++) {
                    if (i > 0 && i <= totalPages) {
                        createPaginationItem(i, () => setPageNumber(i));
                    }
                }

                createPaginationItem('. . . .', () => { });

                createPaginationItem(totalPages, () => setPageNumber(totalPages));
                createPaginationItem('>', addCounter);
            }

            if (pageNumber >= tp - 4 && totalPages) {
                createPaginationItem('<', delCounter);
                createPaginationItem(1, () => setPageNumber(1));
                createPaginationItem('. . . .', () => { });

                for (let i = tp - 4; i <= totalPages; i++) {
                    if (i > 0 && i <= totalPages) {
                        createPaginationItem(i, () => setPageNumber(i));
                    }
                }

                createPaginationItem('>', addCounter);
            }
        }

        // Function to update the loading array
        function updateLoadingArray(loadingArray, movies) {
            const loadingArrayContainer = document.getElementById('loadingArray');
            loadingArrayContainer.innerHTML = '';

            loadingArray.forEach((array, index) => {
                const div = createElement('div', {
                    'class': `outer content ${movies.length === 0 ? "display" : " hide"}`,
                });

                const innerDiv = createElement('div', {
                    'class': 'movieLoading',
                });

                const img = createElement('img', {
                    'alt': '',
                    'src': 'https://retchhh.files.wordpress.com/2015/03/loading1.gif',
                });

                innerDiv.appendChild(img);
                div.appendChild(innerDiv);
                loadingArrayContainer.appendChild(div);
            });
        }

        // Function to update the movies
        function updateMovies(movies) {
            const moviesContainer = document.getElementById('movies');
            moviesContainer.innerHTML = '';

            movies.forEach((movie, index) => {
                const div = createElement('div', {
                    'class': 'outer',
                });

                const link = createElement('div', {
                    'class': 'link',
                    'href': ``,
                });

                const rowContentDiv = createElement('div', {
                    'class': `row content ${movies.length === 0 ? "hide" : " "}`,
                });

                const subContent1Div = createElement('div', {
                    'class': 'subContent1',
                });

                const img = createElement('img', {
                    'alt': '',
                    'src': `https://image.tmdb.org/t/p/w300/${movie.poster_path}`,
                    'width': '100px',
                    'height': '120px',
                });

                const textAlignLeftDiv = createElement('div', {
                    'class': 'textAlignLeft subContent2',
                });

                const h3 = createElement('h3', {
                    'class': 'movieTitle',
                });
                h3.textContent = movie.title;

                const releaseDateSpan = createElement('span', {
                    'class': 'releaseDate fontSize14px',
                });
                releaseDateSpan.textContent = movie.release_date;

                const pOverview = createElement('p', {
                    'class': 'overview fontSize13px',
                });
                pOverview.textContent = movie.overview;


                subContent1Div.appendChild(img);
                textAlignLeftDiv.appendChild(h3);
                textAlignLeftDiv.appendChild(releaseDateSpan);
                textAlignLeftDiv.appendChild(pOverview);
                rowContentDiv.appendChild(subContent1Div);
                rowContentDiv.appendChild(textAlignLeftDiv);
                link.appendChild(rowContentDiv);
                div.appendChild(link);
                moviesContainer.appendChild(div);
            });
        }



        // Initial state
        let movies = [];
        let totalPages = null;
        let pageNumber = 1;
        const loadingArray = [1, 2, 3, 4, 5, 6, 7, 8];

        // Function to fetch movies
        function fetchMovies(pageNumber) {
            const endpoint = `https://api.themoviedb.org/3/trending/movie/week?api_key=d908cdc5e4223e480c0497b5a861d68d&page=${pageNumber}`;
            fetch(endpoint)
                .then(blob => blob.json())
                .then(api => {
                    //movies = api.results;
                    movies = movies.concat(api.results);
                    totalPages = api.total_pages;
                    updateLoadingArray(loadingArray, movies);
                    updateMovies(movies);
                    updatePagination(pageNumber, totalPages);
                });
        }


        function loadMoreMovies() {
            if (pageNumber < totalPages) {
                setPageNumber(pageNumber + 1);
            }
        }

        const intersectionObserver = new IntersectionObserver(entries => {
            entries.forEach(entry => {
                if (!entry.isIntersecting) {
                    return;
                }
                loadMoreMovies();
            });
        });


        intersectionObserver.observe(document.querySelector(".virtual"));

        // Initial fetch
        fetchMovies(pageNumber);

    </script>
</body>


</html>